summaryrefslogtreecommitdiff
path: root/scripts/ipkg-build
authorwimpie <wimpie>2004-04-02 16:49:47 (UTC)
committer wimpie <wimpie>2004-04-02 16:49:47 (UTC)
commit9e26c10c0dc97a0956d019166caf712955094764 (patch) (side-by-side diff)
tree9bf4f33bd02185780070e178d25e24bdff4d6cd2 /scripts/ipkg-build
parent2f2d702e37cc391dd547eaa7e2432d86285e546d (diff)
downloadopie-9e26c10c0dc97a0956d019166caf712955094764.zip
opie-9e26c10c0dc97a0956d019166caf712955094764.tar.gz
opie-9e26c10c0dc97a0956d019166caf712955094764.tar.bz2
ipkg-build mkipkg : speedup (avoid grepping over controlfile by loading into array)
SpeciapMTFiles tothreaded : convert control files to -mt.control
Diffstat (limited to 'scripts/ipkg-build') (more/less context) (ignore whitespace changes)
-rwxr-xr-xscripts/ipkg-build63
1 files changed, 52 insertions, 11 deletions
diff --git a/scripts/ipkg-build b/scripts/ipkg-build
index c6af056..b661bbf 100755
--- a/scripts/ipkg-build
+++ b/scripts/ipkg-build
@@ -5,22 +5,57 @@
# based on a script by Steve Redler IV, steve@sr-tech.com 5-21-2001
set -e
-ipkg_extract_value() {
- sed -e "s/^[^:]*:[[:space:]]*//"
+#declare array for values and fields found in control file
+declare -a AllValues AllFields
+
+collect_values() {
+ local i line
+
+ i=0
+ while read line
+ do
+ AllFields[$i]=${line%%:*}
+ AllValues[$i]=`echo ${line#*:}` # echo to remove spaces
+ let i=i+1
+ done < ${pkg_dir}/${CONTROL}/control
}
required_field() {
- field=$1
-
- value=`grep "^$field:" < $CONTROL/control | ipkg_extract_value`
- if [ -z "$value" ]; then
- echo "*** Error: $CONTROL/control is missing field $field" >&2
- return 1
- fi
- echo $value
- return 0
+ local field i
+ field=$1
+
+ i=0
+ for af in "${AllFields[@]}"
+ do
+ if [ "$field" = "$af" ]
+ then
+ # return value
+ echo "${AllValues[$i]}"
+ return 0;
+ fi
+ let i=i+1
+ done
+ # not found
+ echo "*** Error: $CONTROL/control is missing field $field" >&2
+ return 1
}
+#ipkg_extract_value() {
+# sed -e "s/^[^:]*:[[:space:]]*//"
+#}
+#
+#required_field() {
+# field=$1
+#
+# value=`grep "^$field:" < $CONTROL/control | ipkg_extract_value`
+# if [ -z "$value" ]; then
+# echo "*** Error: $CONTROL/control is missing field $field" >&2
+# return 1
+# fi
+# echo $value
+# return 0
+#}
+
pkg_appears_sane() {
local pkg_dir=$1
@@ -137,6 +172,9 @@ while getopts "cg:o:" opt; do
esac
done
+# maks sure that tar produces headers compatible with busybox format
+# debian needs this
+ogargs="$ogargs --format=oldgnu"
shift $(($OPTIND - 1))
@@ -171,6 +209,9 @@ if [ -z "$CONTROL" ]; then
exit 1
fi
+# load values
+collect_values
+
if ! pkg_appears_sane $pkg_dir; then
echo >&2
echo "ipkg-build: Please fix the above errors and try again." >&2